#
# This script was written by Renaud Deraison <deraison@cvs.nessus.org>
#
# See the Nessus Scripts License for details
#

if(description)
{
 script_id(10809);
 script_version ("$Revision: 1.5.2.1 $");
 
 name["english"] = "Sendmail -bt option";
 name["francais"] = "Option -bt de sendmail";
 script_name(english:name["english"],
 	     francais:name["francais"]);
 
 desc["english"] = "
The remote sendmail server, according to its version number,
may be vulnerable to the -bt overflow attack which
allows any local user to execute arbitrary commands as root.

Solution : upgrade to the latest version of Sendmail
Risk factor : High
Note : This vulnerability is _local_ only"; 

	

 desc["francais"] = "
Le serveur sendmail distant, d'aprs son numro de version,
est vulnrable  un dpassement de buffer par l'option -bt,
permettant  n'importe quel utilisateur local d'executer
des commandes en tant que root.

Solution : mettez  jour sendmail
Facteur de risque : Elev
Note : cette vulnrabilit est locale uniquement";

 script_description(english:desc["english"],
 	 	    francais:desc["francais"]);
		    
 
 summary["english"] = "Checks the version number"; 
 summary["francais"] = "Vrification du numro de srie de sendmail";
 script_summary(english:summary["english"],
 		 francais:summary["francais"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2001 Renaud Deraison",
 		  francais:"Ce script est Copyright (C) 2001 Renaud Deraison");
 
 family["english"] = "SMTP problems";
 family["francais"] = "Problmes SMTP";
 script_family(english:family["english"], francais:family["francais"]);
 script_dependencie("find_service.nes","smtpserver_detect.nasl");
 script_require_keys("SMTP/sendmail");
 script_require_ports("Services/smtp", 25);
 exit(0);
}

#
# The script code starts here
#

include("smtp_func.inc");

port = get_kb_item("Services/smtp");
if(!port) port = 25;

banner = get_smtp_banner(port: port);

if(banner)
{
 if(ereg(pattern:".*Sendmail.*8\.(([0-9]\..*)|(10\..*)|(11\.[0-2])).*",
	string:banner))
 	security_hole(port);
}
